'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 7 February 2004 at 4:23:39 pm'!
TestCase subclass: #KomServicesTests
	instanceVariableNames: 'service '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomServices'!
TestCase subclass: #KomTcpServicesTests
	instanceVariableNames: 'service tcpService '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomServices'!

!KomServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 10:26'!
setUp
		service _ Service newNamed: 'testing'.!
]style[(8 7 3 7 11 9 1)f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1! !

!KomServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 10:26'!
tearDown
	Service removeService: service! !

!KomServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 10:26'!
testServiceCreation

	self
		assert: (Service services includes: service).
	service start; stop.
	service unregister.
	self assert: (Service services includes: service) not!
]style[(19 3 4 12 7 20 7 4 7 15 7 14 4 10 7 20 7 5)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!KomServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 10:27'!
testServiceNamed
	self
		assert: (Service serviceNamed: 'testing') notNil.
	service start; stop.
	service unregister.
	self should: [Service serviceNamed: 'testing'] raise: Error!
]style[(16 2 4 12 7 35 7 15 7 14 4 55)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!KomServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 10:27'!
testServiceNamedIfAbsent
	self assert: (Service serviceNamed: 'testing'ifAbsent: []) notNil.
	service start; stop.
	service unregister.
	self assert: (Service serviceNamed: 'testing'ifAbsent: []) isNil.!
]style[(24 2 4 10 7 15 21 11 7 15 7 14 4 10 7 15 21 8)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1! !


!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 12:53'!
setUp
	tcpService _ TcpService on: 55555.
	service _ Service newNamed: 'testing'! !

!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 12:54'!
tearDown
	service unregister.
	tcpService unregister.! !

!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 13:01'!
testServiceOnPort
	self assert: (TcpService serviceOnPort: 55555) notNil.
	self
		should: [TcpService serviceOnPort: 66666]
		raise: Error!
]style[(17 2 4 10 10 16 5 11 4 12 10 16 5 11 5)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;! !

!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 12:59'!
testServiceOnPortIfAbsent
	self assert: (TcpService
			serviceOnPort: 55555
			ifAbsent: []) notNil.
	self assert: (TcpService serviceOnPort: 66666 ifAbsent: []) isNil.!
]style[(25 2 4 10 10 19 5 93)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c200200124,f1! !

!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/6/2004 12:55'!
testServices
	self deny: (TcpService services includes: service)! !

!KomTcpServicesTests methodsFor: 'as yet unclassified' stamp: 'gc 2/7/2004 16:04'!
testTcpServiceCreation
	self assert: (TcpService services includes: tcpService)! !


!Service class methodsFor: 'registration' stamp: 'gc 2/7/2004 16:04'!
addService: aService 
	self allServices add: aService!
]style[(12 8 3 4 18 8)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cblue;i! !

!Service class methodsFor: 'registration' stamp: 'gc 2/7/2004 16:07'!
removeService: aService 
	self allServices
		remove: aService
		ifAbsent: []!
]style[(15 8 3 4 23 8 15)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!Service class methodsFor: 'accessing' stamp: 'gc 2/7/2004 16:21'!
allServices
	"answer all the registered services.

	 Do not override me - override #services"
	^ Services!
]style[(11 2 80 4 8)f1b,f1,f1c152050000,f1,f1cmagenta;! !

!Service class methodsFor: 'accessing' stamp: 'gc 2/6/2004 10:29'!
serviceNamed: aString 
	^ self serviceNamed: aString
		ifAbsent: [self error: 'No service by that name']!
]style[(14 7 5 4 15 7 14 4 8 25 1)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1! !

!Service class methodsFor: 'accessing' stamp: 'gc 2/6/2004 10:28'!
serviceNamed: aString ifAbsent: aBlock
	^ self services
		detect: [:ea | ea name = aString]
		ifNone: aBlock!
]style[(14 7 21 4 21 4 2 2 8 7 18)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1! !

!Service class methodsFor: 'accessing' stamp: 'gc 2/7/2004 16:03'!
services
	^ self allServices! !


!TcpService class methodsFor: 'accessing' stamp: 'gc 2/6/2004 13:00'!
serviceOnPort: portNumber 
	^ self services
		detect: [:ea | ea portNumber = portNumber] ifNone: [self error: 'No service on that port']!
]style[(15 10 5 4 21 4 2 2 14 10 49)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1! !

!TcpService class methodsFor: 'accessing' stamp: 'gc 2/6/2004 12:59'!
serviceOnPort: portNumber ifAbsent: aBlock 
	^ self services
		detect: [:ea | ea portNumber = portNumber] ifNone: aBlock!
]style[(15 10 11 6 5 4 21 4 2 2 14 10 16)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1! !

!TcpService class methodsFor: 'accessing' stamp: 'gc 2/6/2004 12:56'!
services
	| svcs |
	svcs _ super services.
	^ svcs select: [:ea | ea isKindOf: TcpService]! !

